package lcsb.mapviewer.model.cache;

import lcsb.mapviewer.common.Comparator;
import lcsb.mapviewer.common.comparator.StringComparator;

import java.util.Arrays;

public class UploadedFileEntryComparator extends Comparator<UploadedFileEntry> {

  public UploadedFileEntryComparator() {
    super(UploadedFileEntry.class, true);
  }


  @Override
  protected int internalCompare(final UploadedFileEntry arg0, final UploadedFileEntry arg1) {
    StringComparator stringComparator = new StringComparator();

    if (stringComparator.compare(arg0.getOriginalFileName(), arg1.getOriginalFileName()) != 0) {
      logger.debug("Original file name is different: {} != {}", arg0.getOriginalFileName(), arg1.getOriginalFileName());
      return stringComparator.compare(arg0.getOriginalFileName(), arg1.getOriginalFileName());
    }

    if (!Arrays.equals(arg0.getFileContent(), arg1.getFileContent())) {
      logger.debug("Glyph content different for file {}.", arg0.getOriginalFileName());
      return -1;
    }

    return 0;
  }

}
