package lcsb.mapviewer.model.map.model;

import lcsb.mapviewer.common.Comparator;
import lcsb.mapviewer.common.Configuration;

public class ModelDataComparator extends Comparator<ModelData> {

  private final ModelComparator modelComparator;

  public ModelDataComparator(final double epsilon) {
    super(ModelData.class);
    modelComparator = new ModelComparator(epsilon);
  }

  /**
   * Default constructor.
   */
  public ModelDataComparator() {
    this(Configuration.EPSILON);
  }

  @Override
  protected int internalCompare(final ModelData arg0, final ModelData arg1) {
    return modelComparator.compare(new ModelFullIndexed(arg0), new ModelFullIndexed(arg1));
  }
}
